package generateVoyages;

import java.util.ArrayList;

import master.DataReader;

public class Main {
	/**
	 * The Main method initiates a new DataReader instance, the VoyageGenerator and the OutputWriter. The filenames should be changed here in order to solve new problem instances.
	 * @param args
	 */
	public static void main(String[] args){
		for(int i = 0; i < 18; i++){
			String fileName = " ";
			
			switch(i){
			case 0:
				fileName = "Mongstad_4";
				break;
			case 1:
				fileName = "Mongstad_4_Speed";
				break;
			case 2:
				fileName = "Mongstad_4_Triple";
				break;
			case 3:
				fileName = "Mongstad_5";
				break;
			case 4:
				fileName = "Mongstad_5_Speed";
				break;
			case 5:
				fileName = "Mongstad_5_Triple";
				break;
			case 6:
				fileName = "Agotnes_6";
				break;
			case 7:
				fileName = "Agotnes_6_Speed";
				break;
			case 8:
				fileName = "Agotnes_6_Triple";
				break;
			case 9:
				fileName = "Floro_7";
				break;
			case 10:
				fileName = "Floro_7_Speed";
				break;
			case 11:
				fileName = "Floro_7_Triple";
				break;
			case 12:
				fileName = "Agotnes_8";
				break;
			case 13:
				fileName = "Agotnes_8_Speed";
				break;
			case 14:
				fileName = "Agotnes_8_Triple";
				break;
			case 15:
				fileName = "Agotnes_8_1ExtraDel";
				break;
			case 16:
				fileName = "Mongstad_10_Triple";
			case 17:
				fileName = "Floro_11_Triple";
			default:
				break;
			}
			
			long startTime = System.nanoTime();
			
			DataReader input = new DataReader(fileName + ".txt");
			System.out.println("File running: " +fileName);
	
//			VoyageGenerator is run for the given input file
			ArrayList<ArrayList<State>> voyages = new ArrayList<ArrayList<State>>();
			VoyageGenerator voyGen = new VoyageGenerator();
			voyages = voyGen.findAllVoyages(input);
			
//			The generated voyages for the given input file are written to file by OutputWriter
			try {
				OutputWriter.writeOutputFile(voyages, input, fileName);
			} catch (CloneNotSupportedException e) {
				e.printStackTrace();
			}
			
			for(ArrayList<State> vessel:voyages){
				System.out.println("Number of possible voyages for Vessel " + (voyages.indexOf(vessel)+1) + ": " + vessel.size());
			}
			
			long endTime = System.nanoTime();
			System.out.println("Runtime "+ (endTime-startTime)/1000000 + " ms");
		}
	}
}

