package master;

import java.util.HashMap;

import org.jxmapviewer.viewer.GeoPosition;

/**
 * Parent class for pickup and delivery nodes. Used to represent offshore installations
 * @author Nils Albjerk
 * @author Teodor Danielsen
 * @author Stian Krey
 *
 */
public class Node {
	private int nodeNumber;
	private String nodeName;
	private double priority;
	
	private HashMap<Node, Double> sailingCosts;
	private HashMap<Node, Double> sailingTime;
	
	Node sibling;
	
	private GeoPosition position;
	
	public Node(int nodeNumber, double priority){
		this.setNodeNumber(nodeNumber);
		this.setPriority(priority);
		sailingCosts = new HashMap<Node, Double>();
		sailingTime = new HashMap<Node, Double>();
	}
	
	public int getNodeNumber() {
		return nodeNumber;
	}

	public void setNodeNumber(int nodeNumber) {
		this.nodeNumber = nodeNumber;
	}
	
	public HashMap<Node, Double> getSailingCosts() {
		return sailingCosts;
	}

	public void setSailingCosts(HashMap<Node, Double> sailingCosts) {
		this.sailingCosts = sailingCosts;
	}

	public Double getServiceSailingCosts(Node key){
		return sailingCosts.get(key);
	}
	
	public void addServiceSailingCosts(Node key, Double value){
		sailingCosts.put(key, value);
	}
	
	public Double getSailingTime(Node key){
		return sailingTime.get(key);
	}
	
	public void addSailingTime(Node key, Double value){
		sailingTime.put(key, value);
	}

	public Node getSibling() {
		return sibling;
	}

	public void setSibling(Node sibling) {
		this.sibling = sibling;
	}

	public GeoPosition getPosition() {
		return position;
	}

	public void setPosition(GeoPosition position) {
		this.position = position;
	}

	public String getNodeName() {
		return nodeName;
	}

	public void setNodeName(String nodeName) {
		this.nodeName = nodeName;
	}

	public double getPriority() {
		return priority;
	}

	public void setPriority(double priority) {
		this.priority = priority;
	}
}

